import { FunctionComponent } from 'react';
declare const withCondition: unique symbol;
declare const withConditionalFallback: unique symbol;
declare const withConditionalRender: unique symbol;
declare module '@modular-component/core' {
    interface ModularStages<Args, Value> {
        [withCondition]: {
            restrict: (args: Args) => boolean;
            transform: ReturnType<Value extends (args: Args) => boolean ? Value : never>;
        };
        [withConditionalFallback]: {
            restrict: FunctionComponent<Args>;
            transform: ReturnType<FunctionComponent<Args>> | null;
        };
        [withConditionalRender]: {
            restrict: FunctionComponent<Args>;
            transform: ReturnType<FunctionComponent<Args>> | null;
        };
    }
}
export declare const WithConditionalRender: {
    readonly Condition: {
        readonly symbol: typeof withCondition;
        readonly field: "condition";
        readonly transform: <A extends {
            condition?: boolean | undefined;
        }, C extends (args: A) => boolean>(args: A, useCondition: C) => boolean;
    };
    readonly ConditionalRender: {
        readonly symbol: typeof withConditionalRender;
        readonly field: "render";
        readonly transform: <A_1 extends {
            condition?: boolean | undefined;
            render?: import("react").ReactElement<any, any> | null | undefined;
        }, P extends FunctionComponent<A_1>>(args: A_1, useRender: P) => import("react").ReactElement<any, any> | null | undefined;
    };
    readonly ConditionalFallback: {
        readonly symbol: typeof withConditionalFallback;
        readonly field: "render";
        readonly transform: <A_2 extends {
            condition?: boolean | undefined;
            render?: import("react").ReactElement<any, any> | null | undefined;
        }, P_1 extends FunctionComponent<A_2>>(args: A_2, useRender: P_1) => import("react").ReactElement<any, any> | null | undefined;
    };
};
export {};
//# sourceMappingURL=index.d.ts.map