import { createMethodRecord } from '@modular-component/core';
const withCondition = Symbol();
const withConditionalFallback = Symbol();
const withConditionalRender = Symbol();
export const WithConditionalRender = createMethodRecord({
    Condition: {
        symbol: withCondition,
        field: 'condition',
        transform: (args, useCondition) => args.condition !== false && useCondition(args),
    },
    ConditionalRender: {
        symbol: withConditionalRender,
        field: 'render',
        transform: (args, useRender) => {
            if (args.condition === false) {
                return args.render;
            }
            return useRender(args);
        },
    },
    ConditionalFallback: {
        symbol: withConditionalFallback,
        field: 'render',
        transform: (args, useRender) => {
            if (args.condition !== false || args.render) {
                return args.render;
            }
            return useRender(args);
        },
    },
});
//# sourceMappingURL=index.js.map